*
* Le manoir de la crapule
* Fichier : Engine (le moteur du jeu)
*
* (c) 1987, Jean-Louis Le Breton, Froggy Software
* (c) 2017, Antoine Vignau & Olivier Zardini, Brutal Deluxe Software
*

	mx	%11
	org	$800
	lst	off
	dsk	Engine

*------------------------------------------------------------------------------
* Equates & friends
*------------------------------------------------------------------------------

*--- Des equates

engineVERSION	=	$13	; this is version 1.3 (1.7 would be $17)

sizeCONDITIONS	=	90	; le moteur gère 90 conditions au maximum
sizeMOT	=	100	; longueur maximale de saisie par le joueur en 80-cols
valCONDITION	=	200	; >200, c'est une condition à traiter

false	=	$00	; valeur FAUX
true	=	$80	; valeur VRAI

samegame	=	"C"	; signifie qu'on continue le jeu actuel !
newgame	=	"N"	; signifie qu'on veut démarrer une nouvelle partie
loadgame	=	"L"	; signifie qu'on a chargé une ancienne partie
endofgame	=	"Q"	; signifie qu'on veut quitter le jeu

eod	=	$ff	; end of data
andBIT7	=	$7f	; vire le bit 7
maskBIT7	=	$80	; le masque du bit 7 (ben, oui, pourquoi pas)

chrLARROW	=	$88	; left arrow
chrRARROW	=	$95	; right arrow
chrUARROW	=	$8b	; up arrow
chrDARROW	=	$8a	; down arrow

cursorCHAR	=	">"	; le curseur du jeu (ben, oui, pourquoi pas)

chrRET	=	$0d	; carriage return
chrRET2	=	$8d	; carriage return 2
chrSPC	=	$20	; space
chrSPC2	=	" "	; space 2
chrESC	=	$1b	; escape
chrESC2	=	$9b	; escape 2
chrDOT	=	$2e	; dot
chrDOT2	=	"."	; dot 2
chrQM	=	$3f	; question mark
chrQM2	=	"?"	; question mark2
chra	=	$61	; a
chrz	=	$7a	; z
chrSLASH2	=	"/"	; slash
chrDEL	=	$7f	; delete
chrDEL2	=	$ff	; delete 2

*--- Des pointeurs

* tblGame		; 01 - 00 - les paramètres du jeu
* tblDirections	; 02 - 02 - les directions autorisées dans chacune des pièces
* tblCas		; 03 - 04 - le nombre de cas possibles par pièce
* tblCasImage		; 04 - 06 - le tableau de correspondance des situations/messages/conditions par pièce
* tblConditions	; 05 - 08 - le tableau des conditions du jeu (en fait, la solution)
* tblSituations	; 06 - 0A - les situations possibles par pièce
* tblSystemMessages	; 07 - 0C - les messages du moteur (AV: histoire de faire de l'I18N facilement)
* tblSystemDictionnaire	; 08 - 0E - le dictionnaire du moteur (AV: histoire de faire l'I18N facilement)
* tblDictionnaire	; 09 - 10 - le dictionnaire du jeu
* tblMessagesImage	; 10 - 12 - les phrases qui accompagnent chaque image
* tblMessages		; 11 - 14 - les messages du jeu
* tblDialogues		; 12 - 16 - les dialogues du jeu (quand on interroge quelqu'un)
* tblConditionsImage	; 13 - 18 - Le tableau qui choisit l'image à afficher selon des critères
* tblPlan		; 14 - 1A - le tableau des dialogues pour le plan du jeu
* tblSituationsImage	; 15 - 1C - le tableau du numéro de pièce réel associé à une image

*--- My zero page usage

PROMPT	=	$33	; firmware
CSWL	=	$36	; firmware
CSWH	=	$37	; firmware
A1L	=	$3c	; firmware
A1H	=	$3d	; firmware
A2L	=	$3e	; firmware
A2H	=	$3f	; firmware
A4L	=	$42	; firmware
A4H	=	$43	; firmware
RNDL	=	$4e	; firmware

dpSituations	=	$F0	; $F0 - zero page usage for situations
dpCasImage	=	dpSituations+2	; $F2
dpConditions	=	dpCasImage+2	; $F4

dpDICOSTART	=	$f0	; $F0 - zero page usage for the dictionaries
dpDICOEND	=	dpDICOSTART+2	; $F2

dpFROM	=	$f6	; $F6 - global zero page usage
dpTO	=	dpFROM+2	; $F8
dpDATA	=	dpTO+2	; $FA
dpWORK	=	dpDATA+4	; $FE

*--- Memory usage / ProDOS equates

TEXTBUFFER	=	$200	; This is where GETLN stores its data
ptrIMAGE	=	$2000	; a text/pic image is visible at $2000
ptrIMAGE80	=	$2400	; a text/pic image 80-col or DGR
ptrPAGE2800	=	$2800	; ditto!
ptrPAGE4000	=	$4000	; a text/pic HGR/DHGR/SHR
loadBUFFER	=	$b000	; ProDOS read buffer
proBUFFER	=	$b800	; ProDOS open buffer
PRODOS	=	$bf00	; The MLI entry point
MACHID	=	$bf98	; The machine ID calculated by ProDOS

mask128K	=	%00110000	; 01: 48K, 10: 64K, 11: 128K+
mask80COL	=	%00000010	; 0: 40-col, 1: 80-col

*--- Game data equates

data48K	=	%00010000	; 01: 48K, 10: 64K, 11: 128K+
data64K	=	%00100000	; 01: 48K, 10: 64K, 11: 128K+
data128K	=	%00110000	; 01: 48K, 10: 64K, 11: 128K+

text40COL	=	%00000000	; 0: 40-col, 1: 80-col
text80COL	=	%00000010	; 0: 40-col, 1: 80-col

picNOPICS	=	%00000000	; no picture, text only game
picTEXT40	=	%00000001	; 40x24
picTEXT80	=	%00000010	; 80x24
picGR	=	%00000011	; 40x48
picDGR	=	%00000100	; 80x48
picHGR	=	%00000101	; 140x192
picHGRMONO	=	%00000110	; 280x192
picDHGR	=	%00000111	; 140x192
picDHGRMONO	=	%00001000	; 560x192
picSHR320	=	%00001001	; 320x200
picSHR640	=	%00001010	; 640x200
picUNSUPPORTED	=	%00001011	; unsupported

compNONE	=	%00000000	; picture is not compressed
compLZ4	=	%00000001	; picture uses LZ4
compUNSUPPORTED =	%00000010	; unsupported

*--- The softswitches

KBD	=	$c000
CLR80COL	=	$c000
SET80COL	=	$c001
CLR80VID	=	$c00c
SET80VID	=	$c00d
KBDSTROBE	=	$c010
MONOCOLOR	=	$c021
NEWVIDEO	=	$c029
TXTCLR	=	$c050
TXTSET	=	$c051
MIXCLR	=	$c052
MIXSET	=	$c053
TXTPAGE1	=	$c054
TXTPAGE2	=	$c055
LORES	=	$c056
HIRES	=	$c057
CLRAN	=	$c05d
SETAN3	=	$c05e
CLRAN3	=	$c05f

*--- The firmware routines

AUXMOVE	=	$C311
INIT	=	$FB2F
TABV	=	$FB5B
BS	=	$FC10
HOME	=	$FC58
CLREOL	=	$FC9C
RDKEY	=	$FD0C
KEYIN	=	$FD1B
GETLNZ	=	$FD67
GETLN	=	$FD6A
CROUT	=	$FD8E
PRBYTE	=	$FDDA
COUT	=	$FDED
IDROUTINE	=	$FE1F
SETNORM	=	$FE84
SETKBD	=	$FE89
BEEP	=	$FF3A

*------------------------------------------------------------------------------
*
* LES POINTS D'ENTREE
*
*------------------------------------------------------------------------------

	jmp	leJEU
	jmp	initGAME
	jmp	initTEXT
	jmp	chargeIMAGE	; Image number is numDESSIN
	jmp	chargeIMAGEALT	; You provide the image number
	jmp	switchVIDEOTER	; You provide the video mode
	jmp	setDATA
	jmp	setPOINTER
	jmp	setHOOK	; X=high ptr, Y=low ptr to a table, read carefully
	jmp	getHOOKTABLE
	
*------------------------------------------------------------------------------
* LE CODE PRINCIPAL
*------------------------------------------------------------------------------

leJEU

debutdujeu	
	jsr	initGAME		; on initialise le jeu
	jsr	initTEXT		; on passe en 80-colonnes ou pas
	jsr	printDIALOGUE		; Affiche le dialogue par défaut
	jsr	printMESSAGE		; Affiche le message par défaut
	
	lda	#0		; quelques inits
	sta	numMESSAGE
	sta	numSYSTEMMESSAGE
	jsr	initICONS		; charge une belle image
	
chargejeu
	lda	#chrRET2
	jsr	COUT
	jsr	printMESSAGEIMAGE	; Affiche le message de l'image

	jsr	onEntry		; call your hook routine

	lda	#false
	sta	fgMORT		; we are alive
	sta	fgGAGNE		; we have not won

*--- The main loop
	
]lp	jsr	attenteMOT		; on attend le mot saisi
	bcc	]lp
	
	jsr	duringPlay		; call your hook routine
	bcc	]lp		; *YOU* have handled the command

cestunmot	jsr	verifieSYSTEMDICTIONNAIRE	; on vérifie le mot dans le dictionnaire
	bcc	]lp		; on a traité le mot

	cmp	#newgame		; on démarre une nouvelle partie !
	beq	debutdujeu
	cmp	#loadgame		; on recharge une partie en cours !
	beq	chargejeu
	cmp	#samegame		; on a voulu changer mais on n'a pas pu !
	beq	]lp
	cmp	#endofgame		; on a décidé de quitter !
	beq	findujeu

	jsr	checkSCORE		; if we have won, tell the player
	bcs	]lp		; and loop!
	
	jsr	verifieDICTIONNAIRE	; on vérifie dans le dictionnaire
	jmp	]lp		; et on boucle

findujeu	jsr	onExit		; call your hook routine
	jsr	PRODOS
	dfb	$65
	da	proQUIT
	brk	$bd		; on ne se refait pas ;-)

*--- Data

proQUIT	dfb	$04
	ds	1
	ds	2
	ds	1
	ds	2	

proSETPFX	dfb	$01
	da	$280

*------------------------------------------------------------------------------
*
* LES ROUTINES DU JEU
*
*------------------------------------------------------------------------------

*------------------------------------------------------------------------------
* Les routines de la logique de la partie
*------------------------------------------------------------------------------

*--------------------------------------
* verifieDICTIONNAIRE
*
* Vérifie si le mot saisi est dans le
* dictionnaire et le traite
*
*--------------------------------------

verifieDICTIONNAIRE
	ldx	tailleDICTIONNAIRE
	lda	#9	; dictionnaire
	jsr	analyse	; analyse le mot
	jsr	DEBUG	; oh, le joli mode debug !

	jsr	getSITUATION	; get the list of situations
	jmp	comparaison	; compare them and return

*--- Data

fgMORT	ds	1	; false if alive, true if dead
fgGAGNE	ds	1	; true if you did it!

*--------------------------------------
* getSITUATION
*
* Récupère le nb de situations
* de l'image courante
*
*--------------------------------------

getSITUATION
	jsr	getDESSINSITUATION
	bcc	getSITUATION1
	rts

getSITUATION1
	pha	

	lda	#3	; ici, on veut le nombre de cas pour la boucle
	jsr	setDATA

	pla		; le nombre de cas par image
	pha
	sec		; -1
	sbc	#1
	tay
	lda	(dpDATA),y	; get the value from tblCas
	sta	nbSITUATIONS

* On passe maintenant à la liste des situations

	lda	#6	; ici, on veut la liste des situations
	jsr	setDATA

	pla		; le nombre de situations par image
	pha
	jsr	setPOINTER
	sty	dpSituations
	stx	dpSituations+1
	
* On passe maintenant à la liste des cas par image

	lda	#4	; ici, on veut la liste des cas par image
	jsr	setDATA

	pla		; la liste des cas par image
	jsr	setPOINTER
	sty	dpCasImage
	stx	dpCasImage+1

	rts		; on a tout récupéré, il faut gérer maintenant !

*--- Data

nbSITUATIONS	ds	1

*--------------------------------------
* getDESSINSITUATION
*
* En fonction de l'image, on associe
* la situation réelle (on a plus d'images)
* que de pièces
*
*--------------------------------------

getDESSINSITUATION
	lda	#15		; get tblSituationsImage
	jsr	setDATA
	
	lda	numDESSIN		; récupère le vrai numéro de situation
	sec
	sbc	#1
	tay
	lda	(dpDATA),y	; le retourne dans A, -1 est une mauvaise valeur
	cmp	#eod
	beq	getREALIMAGE1
	clc			; c'est bon
	rts
getREALIMAGE1	sec			; erreur
	rts

*--------------------------------------
* comparaison
*
* Vérification des mots saisis avec
* les conditions possibles
*
*--------------------------------------

comparaison
	lda	fgMORT	; est-on mort ?
	bpl	comparaison1
	jmp	comparaison7	; oui !
	
comparaison1	lda	#false	; no matching condition found
	sta	fgTROUVE
	sta	fgCR	; pas de message affiché déjà
	
	ldx	#0
]lp	stx	k	; our counter

*--- Step 1: we prepare the comparison list
* On entry: unused listeMOTS are set to -1

comparaison2	ldy	#0	; compare please
	lda	(dpSituations),y
	cmp	listeMOTS	; word 1
	bne	comparaison4
	iny
	lda	(dpSituations),y
	cmp	listeMOTS+1	; word 2
	bne	comparaison4
	iny
	lda	(dpSituations),y
	cmp	listeMOTS+2	; word 3
	bne	comparaison4

	lda	#true	; we have found a match!
	sta	fgTROUVE

*--- Step 2: see if we have a condition (was getcorres)

	txa		; we are in 6502!
	tay
	lda	(dpCasImage),y
	cmp	#valCONDITION	; is it a condition?
	bcc	comparaison3	; no, it is a message
	beq	comparaison3	; no, it is a message

*--- Step 3: we have a condition, handle it

	sec		; we have a condition
	sbc	#valCONDITION
	jsr	getCONDITION	; handle it, please! - Message to print in A

	cmp	numMESSAGE	; sauf si c'est le même message qu'avant !
	beq	comparaison4
	
comparaison3	sta	numMESSAGE	; save the message index and loop

	lda	fgCR	; a-t-on déjà affiché un message ?
	bpl	comparaisonRC	; non

	lda	#chrRET2	; oui, donc un RC
	jsr	COUT
	
comparaisonRC	jsr	printMESSAGE	; affiche le message

	lda	#true
	sta	fgCR	; et indique qu'on a déjà affiché un mot
	
comparaison4	lda	dpSituations	; next situation
	clc
	adc	#3	; size of the table
	sta	dpSituations
	lda	dpSituations+1
	adc	#0
	sta	dpSituations+1
	
	ldx	k	; next condition
	inx
	cpx	nbSITUATIONS
	bne	]lp

*--- Step 4: check the language!

	lda	fgTROUVE	; did we find a match?
	bpl	comparaison5	; no, so jump to that part
	rts

*--- Is that "bonjour" or a big word?	

comparaison5	ldy	#73	; "bonjour inspecteur"
	lda	listeMOTS	; prend le mot
	beq	comparaison6	; 00, c'est bonjour
	cmp	#99	; 99, c'est un gros mot
	bne	comparaison7
	dey		; "surveillez votre langage"
comparaison6	tya
	sta	numMESSAGE
	jmp	printMESSAGE

comparaison7	lda	#8	; "je ne comprends pas"
	sta	numSYSTEMMESSAGE
	jmp	printSYSTEMMESSAGE

*--- Data

k	ds	1	; our counter
fgTROUVE	ds	1	; did we find a matching situation?
fgCR	ds	1	; si on a déjà affiché un mot, il faut faire un RC

*--------------------------------------
* getCONDITION
*
* Traite les conditions du jeu
*
*--------------------------------------

getCONDITION
	pha			; save the condition

	lda	#5		; ici, on veut la liste des conditions
	jsr	setDATA

* Set the pointer to the tblConditions entry

	ldx	dpDATA+1
	stx	dpConditions+1
	ldy	dpDATA
	sty	dpConditions

	jsr	DEBUGCOND		; show conditions on entry
	
* Reset two flags to ease branches

	lda	#false
	sta	ncv		; condition à vérifier
	sta	ncm		; condition à modifier
	
	pla			; get the condition
	sec
	sbc	#1
	beq	getCOND2

	tax			; on se sert du numéro comme index
]lp	lda	dpConditions		; on part de zéro alors
	clc
	adc	#6
	sta	dpConditions
	lda	dpConditions+1		; we calc that way because
	adc	#0		; the table may exceed 256 bytes
	sta	dpConditions+1
	dex
	bne	]lp		; we exit with the right entry in tblConditions

*--- Step 1: check condition à vérifier / condition à modifier

getCOND2	
	ldy	#0		; condition à vérifier
	lda	(dpConditions),y
	sec
	sbc	#1
	tax
	lda	conditions,x		; con[NCV]
	sta	ncv		; save it
	bpl	getCOND4		; false

	ldy	#1		; condition à modifier
	lda	(dpConditions),y
	sta	tempCOND		; condition temporaire pour la mort !
	sec
	sbc	#1
	tax
	lda	#true
	sta	conditions,x		; con[NCM]

*--- Step 2: get condition à modifier for message

getCOND4	ldy	#1		; condition à modifier
	lda	(dpConditions),y
	sec
	sbc	#1
	tax
	lda	conditions,x		; con[NCM]
	sta	ncm
	
	ldy	#3		; MNON - message si non
	lda	ncm
	bpl	getCOND5
	ldy	#2		; MOUI - message si oui
getCOND5	lda	(dpConditions),y
	sta	x		; there is always a message to print!

*--- Step 3: get image

	lda	ncv		; is condition met?
	bpl	getCOND6
	ldy	#4		; yes, get the potential picture to load
	lda	(dpConditions),y	; IM - image à modifier
	cmp	#eod		; it is -1, no pic to change
	beq	getCOND6
	
	sta	numDESSIN		; save new picture to load
	jsr	initICONS		; load a picture

*--- Step 4: display dialogue

getCOND6	lda	ncm		; is condition met?
	bpl	getCOND7
	ldy	#5		; yes, get the potential dialogue to print
	lda	(dpConditions),y	; AL - le dialogue
	cmp	#eod		; it is -1, no dialog to change
	beq	getCOND7

	sta	numDIALOGUE		; save dialog index
	jsr	printDIALOGUE		; print dialog

	lda	#chrRET2		; print a CR
	jsr	COUT
	
*--- Prepare exit

getCOND7	jsr	DEBUGCOND		; DEBUG des conditions

*--- Check death

	lda	tempCOND		; notre condition activée
	cmp	deathCONDITION		; est-elle la mort ?
	bne	getCOND8		; non, ouf !

	lda	#true		; You are dead!
	sta	fgMORT

*--- Exit now
	
getCOND8	lda	x		; the message to print, if any
	rts

*--- Data

ncv	ds	1	; condition à vérifier
ncm	ds	1	; condition à modifier
x	ds	1	; message to print
tempCOND	ds	1	; condition modifée comparée à la mort

*------------------------------------------------------------------------------
* Les routines pour le système
*------------------------------------------------------------------------------

*--------------------------------------
* setHOOK
*
* We offer customization of the engine
* The table to be provided is as follows
* An entry can be set free, set an address of $0000
*
* On entry:
*  X: high pointer to a table of pointers
*  Y:  low pointer to a table of pointers
*
* Your table:
*  +00 word onEntry
*  +02 word duringPlay
*  +04 word onExit
*  +06 word beforeDiskAccess
*  +08 word afterDiskAccess
*
* Important note:
*  From duringPlay, return with carry:
*   - clear if you have handled the input command
*   - set to let the engine handle the input line
*
* On exit:
*  X: high pointer to a table of pointers
*  Y:  low pointer to a table of pointers
*  A: engine version (currently $10 for v1.0)
*
* My table:
*  +00 word TEXTBUFFER
*  +02 word dataVERSION
*  +04 word numSYSTEMMESSAGE
*
*--------------------------------------

setHOOK
	sty	dpWORK	; set the pointer
	stx	dpWORK+1	; and get the table
	
	ldy	#0	; onEntry
	lda	(dpWORK),y
	iny
	ora	(dpWORK),y
	beq	setHOOK1
	dey		; set pointer
	lda	(dpWORK),y
	sta	onEntry+1
	iny
	lda	(dpWORK),y
	sta	onEntry+2

setHOOK1	iny		; duringPlay
	lda	(dpWORK),y
	iny
	ora	(dpWORK),y
	beq	setHOOK2
	dey		; set pointer
	lda	(dpWORK),y
	sta	duringPlay+1
	iny
	lda	(dpWORK),y
	sta	duringPlay+2

setHOOK2	iny		; onExit
	lda	(dpWORK),y
	iny
	ora	(dpWORK),y
	beq	setHOOK3
	dey		; set pointer
	lda	(dpWORK),y
	sta	onExit+1
	iny
	lda	(dpWORK),y
	sta	onExit+2

setHOOK3	iny		; before disk access
	lda	(dpWORK),y
	iny
	ora	(dpWORK),y
	beq	setHOOK4
	dey		; set pointer
	lda	(dpWORK),y
	sta	beforeDA+1
	iny
	lda	(dpWORK),y
	sta	beforeDA+2

setHOOK4	iny		; after disk access
	lda	(dpWORK),y
	iny
	ora	(dpWORK),y
	beq	setHOOK5
	dey		; set pointer
	lda	(dpWORK),y
	sta	afterDA+1
	iny
	lda	(dpWORK),y
	sta	afterDA+2

*
*--- Another way to get the pointers to the internal table of the game
*

setHOOK5
getHOOKTABLE
	ldx	#>hookTABLE	; return our table
	ldy	#<hookTABLE
	lda	#engineVERSION
	rts
	
* Dummy routines

onEntry	jmp	dummyHOOK	; when we enter the game
duringPlay	jmp	dummyHOOK	; when we play - must return with SEC if the command is not handled
onExit	jmp	dummyHOOK	; when we leave the game
beforeDA	jmp	dummyHOOK	; before we access the disk drive
afterDA	jmp	dummyHOOK	; after we access the disk drive

*--- The dummy routine

dummyHOOK	sec
	rts

*--- Data

hookTABLE
	da	TEXTBUFFER	; the text input area
	da	dataVERSION	; the entry of the "public" data
	da	numSYSTEMMESSAGE ; entry to the "internal" data

*--------------------------------------
* verifieSYSTEMDICTIONNAIRE
*
* Vérifie si le mot saisi est dans le
* dictionnaire système et le traite
*
*--------------------------------------

verifieSYSTEMDICTIONNAIRE
	ldx	tailleSYSTEMDICTIONNAIRE
	lda	#8	; dictionnaire système
	jsr	analyse	; analyse le mot
	jsr	DEBUG	; Oh, le joli mode debug !
	
	lda	idxMOTS	; nombre de mots trouvés
	bne	VSD1	; on a trouvé un mot
	sec		; on n'a pas trouvé de mot
	rts

VSD1	lda	listeMOTS	; ne traite que le premier mot (N-1)
	asl
	tax
	lda	tblSYSTEME,x
	sta	VSD2+1
	lda	tblSYSTEME+1,x
	sta	VSD2+2
VSD2	jmp	$bdbd	; traite le mot

tblSYSTEME			; c'est la table des actions du moteur
	da	doCHARGER	; ok
	da	doSAUVER	; ok
	da	doQUITTER	; ok
	da	doAPROPOS	; ok
	da	doAIDE	; ok
	da	doVERSION	; ok
	da	doNORD	; ok
	da	doSUD	; ok
	da	doEST	; ok
	da	doOUEST	; ok
	da	doHAUT	; ok
	da	doBAS	; ok
	da	doPLAN	; ok
	da	doNEW	; ok
	da	doDEBUG	; ok
	da	doCOURBE	; ok, aka the score
	da	doTEXTE	; ok, text only mode
	da	doIMAGE	; ok, show pictures if any

*--------------------------------------
* doCHARGER
*
* Chargement d'une partie
*
*--------------------------------------

doCHARGER
	lda	#3	; voulez-vous quitter la partie en cours ?
	sta	numSYSTEMMESSAGE
	jsr	printSYSTEMMESSAGE
	jsr	RDKEY
	cmp	lettresOK	; Oui
	beq	doCHARGER1
	cmp	lettresOK+1	; oui
	beq	doCHARGER1
doCHARGER0	clc
	rts

doCHARGER1	lda	#chrRET2
	jsr	COUT
	lda	#1	; sur quelle partie ?
	sta	numSYSTEMMESSAGE
	jsr	printSYSTEMMESSAGE

	jsr	RDKEY
	cmp	#chrESC2	; on ne veut pas charger
	beq	doCHARGER0
	cmp	#"1"
	bcc	doCHARGER1
	cmp	#"9"+1
	bcs	doCHARGER1

	jsr	preparePARTIE	; on prépare les paramètres
	jsr	loadPARTIE	; on sauve
	bcs	doCHARGER2	; ça n'a pas marché !

	lda	#chrRET2
	jsr	COUT
	lda	#10	; vous reprenez votre ancienne enquête
	sta	numSYSTEMMESSAGE
	jsr	printSYSTEMMESSAGE

* v1.1 - AV 201709 - c'était loadgame qu'il fallait utiliser
*	lda	#loadPARTIE	; on prévient qu'on a chargé un jeu
	lda	#loadgame	; on prévient qu'on a chargé un jeu
	sec
	rts

doCHARGER2	pha		; on a eu une grosse erreur de lecture
	jsr	doSAUVER2	; on prévient de l'erreur !
	pla		; ça veut dire qu'on va démarrer une
	sec		; nouvelle partie malheureusement !
	rts
	
*--------------------------------------
* doSAUVER
*
* Sauvegarde d'une partie
*
*--------------------------------------

doSAUVER
	lda	#4	; voulez-vous enregistrer la partie en cours ?
	sta	numSYSTEMMESSAGE
	jsr	printSYSTEMMESSAGE
	jsr	RDKEY
	cmp	lettresOK	; Oui
	beq	doSAUVER1
	cmp	lettresOK+1	; oui
	beq	doSAUVER1
doSAUVER0	clc
	rts

doSAUVER1	lda	#chrRET2
	jsr	COUT
	lda	#2	; sur quelle partie ?
	sta	numSYSTEMMESSAGE
	jsr	printSYSTEMMESSAGE

	jsr	RDKEY
	cmp	#chrESC2
	beq	doSAUVER0
	cmp	#"1"
	bcc	doSAUVER1
	cmp	#"9"+1
	bcs	doSAUVER1

	jsr	preparePARTIE	; on prépare les paramètres
	jsr	savePARTIE	; on sauve
	bcs	doSAUVER2
	rts
doSAUVER2	lda	#chrRET2
	jsr	COUT
	lda	#11	; si erreur, on prévient
	sta	numSYSTEMMESSAGE
	jsr	printSYSTEMMESSAGE
	
	lda	proERR	; affiche le code d'erreur ProDOS
	jsr	PRBYTE
	clc
	rts

*--------------------------------------
* preparePARTIE
*
* Prépare les données ProDOS pour
* lire/écrire la partie d'un joueur
*
*--------------------------------------

preparePARTIE
	and	#andBIT7
	sta	pPARTIE+12	; quel numéro de partie

	lda	#<pPARTIE	; quoi
	sta	proOPEN+1
	lda	#>pPARTIE
	sta	proOPEN+2
	
	lda	#<conditions	; où
	sta	proWRITE+2
	lda	#>conditions
	sta	proWRITE+3

	lda	#<sizeCONDITIONS	; combien
	sta	proWRITE+4	; similaire à proREAD
	lda	#>sizeCONDITIONS
	sta	proWRITE+5
	rts

*--- Data

pPARTIE	str	'DATA/PARTIEX'	; X = index 12

*--------------------------------------
* doQUITTER
*
* Adieu, monde cruel...
*
*--------------------------------------

doQUITTER
	lda	#3	; voulez-vous quitter la partie en cours ?
	sta	numSYSTEMMESSAGE
	jsr	printSYSTEMMESSAGE
	jsr	RDKEY
	cmp	lettresOK	; Oui
	beq	doQUITTER1
	cmp	lettresOK+1	; oui
	beq	doQUITTER1
	clc
	rts
doQUITTER1	lda	#chrRET2
	jsr	COUT
	jsr	doSAUVER	; on demande si on veut sauver

	lda	#endofgame	; adios...
	sec		; on quitte, ciao !
	rts
	
*--------------------------------------
* doNEW
*
* Une nouvelle partie, l'ami ?
*
*--------------------------------------

doNEW
	lda	#3	; voulez-vous quitter le jeu ?
	sta	numSYSTEMMESSAGE
	jsr	printSYSTEMMESSAGE
	jsr	RDKEY
	cmp	lettresOK	; Oui
	beq	doNEW1
	cmp	lettresOK+1	; oui
	beq	doNEW1
	clc
	rts
doNEW1	lda	#chrRET2
	jsr	COUT
	jsr	doSAUVER	; on demande si on veut sauver

	lda	#newgame	; adios...
	sec		; on quitte, ciao !
	rts
	
*--------------------------------------
* doAPROPOS
*
* Affiche le copyright
*
*--------------------------------------

doAPROPOS
	lda	#2
	sta	numDIALOGUE
	jsr	printDIALOGUE
	clc
	rts

*--------------------------------------
* doAIDE
*
* Affiche une aide pour le joueur
* On affiche 5 mots de manière aléatoire
*
*--------------------------------------

doAIDE
	lda	#5
	sta	numSYSTEMMESSAGE
	jsr	printSYSTEMMESSAGE

	lda	#9	; dictionnaire du jeu
	jsr	setDATA

	lda	RNDL	; c'est le nombre aléatoire
	and	#%0011_1111	; 64 valeurs possibles
	jsr	setPOINTER	; c'est le premier mot du dictionnaire

	lda	#5	; on boucle sur 5 mots
	sta	i

]lp	lda	#chrRET2	; un RC SVP
	jsr	COUT
	ldy	dpFROM	; affiche un mot du dictionnaire
	ldx	dpFROM+1
	jsr	printSTRING2
	
	ldy	#0	; calcule l'adresse
	lda	(dpFROM),y	; du prochain mot
	clc		; à afficher
	adc	#1	; +1 pour la longueur
	clc
	adc	dpFROM
	sta	dpFROM
	lda	dpFROM+1
	adc	#0
	sta	dpFROM+1
	
	dec	i	; next word please
	bne	]lp
	clc
	rts

*--- Data

i	ds	1	; un compteur
	
*--------------------------------------
* doVERSION
*
* Affiche l'information du moteur
*
*--------------------------------------

doVERSION
	lda	#3
	sta	numDIALOGUE
	jsr	printDIALOGUE
	clc
	rts
		
*--------------------------------------
* doPLAN
*
* Affiche le plan
*
*--------------------------------------

* v1.1 - AV 201709 - le plan ne fonctionnait pas dans l'ensemble des pièces

doPLAN
	jsr	getDESSINSITUATION	; ici, on récupère l'image réelle
	bcs	doPLAN1	; erreur
	
	pha		; on sauvegarde le numéro d'image
	
	lda	#14	; ici, on veut le tableau du plan
	jsr	setDATA

	pla		; on récupère de la pile
	
*	lda	nbPIECES	; Le numéro de l'image
*	cmp	numDESSIN	; Est-on au délà des images (ie dans les conditions) ?
*	bcc	doPLAN1	; Oui, on sort
*
*	lda	numDESSIN	; on prend le numéro de l'image
	sec
	sbc	#1	; -1
	tay
	lda	(dpDATA),y	; le numéro du dialogue associé
	sta	numDIALOGUE
	jsr	printDIALOGUE
	clc
doPLAN1	rts

*--------------------------------------
* doNORD, doSUD, doEST, doOUEST
* doHAUT, doBAS
*
* Vérifie les directions
*
*--------------------------------------

doNORD	lda	#1
	hex	2c
doSUD	lda	#2
	hex 	2c
doEST	lda	#3
	hex	2c
doOUEST	lda	#4
	hex	2c
doHAUT	lda	#5
	hex	2c
doBAS	lda	#6
	sta	direc	; sauve la direction demandée

* v1.1 AV 201709 - On est mort, pas de direction possible

	lda	fgMORT
	bpl	canMOVE
	jmp	comparaison7	; "je ne comprends pas"

canMOVE	jsr	direction	; vérifie et retourne
	jsr	initICONS	; charge l'image
	jsr	printMESSAGEIMAGE ; affiche
	clc
	rts
	
*--------------------------------------
* doDEBUG
*
* Gère le mode debug du moteur
*
*--------------------------------------

doDEBUG
	lda	fgDEBUG
	eor	#true
	sta	fgDEBUG
	clc
	rts

*--- Data

fgDEBUG	ds	1	; par défaut, pas de débug

*--------------------------------------
* DEBUG
*
* Affiche quelques données du moteur
* pour faciliter le debug
*
*--------------------------------------

DEBUG
	lda	fgDEBUG
	bne	DEBUG1
	rts
	
DEBUG1	lda	#chrRET2
	jsr	COUT

* le mot trouvé dans mySTRING

	ldx	#>debugWORD
	ldy	#<debugWORD
	jsr	printSTRING2
	ldx	#>lenWORD
	ldy	#<lenWORD
	jsr	printSTRING2
	
* la liste des mots trouvés

	lda	#chrRET2
	jsr	COUT

	ldx	#>debugLISTEMOTS
	ldy	#<debugLISTEMOTS
	jsr	printSTRING2
	lda	idxMOTS
	jsr	PRBYTE
	lda	listeMOTS
	jsr	PRBYTE
	lda	listeMOTS+1
	jsr	PRBYTE
	lda	listeMOTS+2
	jsr	PRBYTE
	
	lda	#chrRET2
	jsr	COUT
	rts

*--- Data
	
debugWORD	str	'Mot : '
debugLISTEMOTS	str	'Liste mots : '

*--------------------------------------
* DEBUGCOND
*
* Affiche quelques données du moteur
* pour faciliter le debug
*
*--------------------------------------

DEBUGCOND
	lda	fgDEBUG
	bne	DEBUGCOND1
	rts
	
DEBUGCOND1	lda	#chrRET2
	jsr	COUT

	ldx	#>debugCOND
	ldy	#<debugCOND
	jsr	printSTRING2

* les 90 conditions

DEBUGCOND2	lda	#chrRET2
	jsr	COUT

	ldy	#1
]lp	tya
	jsr	getDECIMAL
	jsr	PRBYTE
	lda	#":"
	jsr	COUT
	lda	conditions-1,y
	jsr	PRBYTE
	lda	#" "
	jsr	COUT
	iny
	cpy	#sizeCONDITIONS
	bcc	]lp

	lda	#chrRET2
	jsr	COUT
	rts
	
*--- Data

debugCOND	str	'Conditions :'

*--------------------------------------
* doCOURBE
*
* Affiche le score
*
*--------------------------------------

doCOURBE
	lda	#12	; votre score est de...
	sta	numSYSTEMMESSAGE
	jsr	printSYSTEMMESSAGE

	jsr	calcSCORE	; calculate the score
	txa		; en X, notre score
	jsr	getDECIMAL	; le met en décimal
	jsr	PRBYTE	; l'affiche
	lda	#chrSLASH2	; un séparateur
	jsr	COUT
	lda	nbCONDITIONS	; affiche le score total possible
	jsr	getDECIMAL
	jsr	PRBYTE	; affiche l'octet
	clc
	rts
		
*--- Sub-routine

calcSCORE	ldy	#0	; on parcourt le tableau des conditions
	ldx	#0	; on note le score ici
]lp	lda	conditions,y	; on a réussi ?
	beq	calcSCORE1	; non
	inx		; oui, +1
calcSCORE1	iny
	cpy	nbCONDITIONS
	bcc	]lp
	rts
	
*--------------------------------------
* doTEXTE / doIMAGE
*
* Force le mode d'affichage
*
*--------------------------------------

doTEXTE
	lda	numDESSIN	; sauvegarde le numéro du dessin
	sta	oldDESSIN
	
	ldx	#true	; n'affiche que le mode texte
	ldy	#false	; le force
	jmp	doIMAGE1	; un BIT
doIMAGE
	ldx	#false	; affiche le mode graphique
	ldy	#true	; le force
doIMAGE1	stx	fgTEXTE
	sty	fgVIDEO	; force

	lda	oldDESSIN	; doit-on charger l'image ?
	cmp	numDESSIN
	beq	doIMAGE2	; non, c'est la même
	jsr	chargeIMAGE	; oui, elle est différente
	clc		; la routine force l'affichage graphique
	rts
doIMAGE2	jsr	switchVIDEOALT	; même image, pas besoin de charger
	clc
	rts
	
*--- Data

fgTEXTE	ds	1	; flag
oldDESSIN	ds	1	; garde le numéro du dessin

*------------------------------------------------------------------------------
* Les sous-routines du jeu
*------------------------------------------------------------------------------

*--------------------------------------
* checkSCORE
*
* Check if a player has won
*
*--------------------------------------

checkSCORE
	jsr	calcSCORE
	cpx	nbCONDITIONS
	beq	checkSCORE1	; player has won!
	
	lda	#false	; play again!
	sta	fgGAGNE
	clc
	rts

checkSCORE1	lda	fgGAGNE	; did we win?
	bmi	checkSCORE2

	lda	#true	; tell we won
	sta	fgGAGNE

	lda	#chrRET2	; print a CR
	jsr	COUT
	
	lda	#6	; write it on the screen please!
	sta	numSYSTEMMESSAGE
	jsr	printSYSTEMMESSAGE
	jsr	doCOURBE	; print score!
checkSCORE2	sec
	rts

*--------------------------------------
* initICONS
*
* Choisit la bonne image à afficher
*
*--------------------------------------

initICONS			; ce code définit l'image à afficher
	lda	#13	; ici, on veut le tableau image/condition
	jsr	setDATA

]lp	ldy	#0	; on parcourt le tableau
	lda	(dpDATA),y	; 0 - à la recherche de correspondances
	cmp	#eod	; fin du tableau ?
	beq	initICONS3

initICONS1	cmp	numDESSIN	; est-on sur le bon dessin ?
	bne	initICONS2	; non, au suivant

	iny
	lda	(dpDATA),y	; 1 - index de condition
	sec
	sbc	#1
	tax
	iny
	lda	(dpDATA),y	; 2 - valeur true ou false
	cmp	conditions,x	; compare avec ce que l'on a actuellement
	bne	initICONS2	; différent, on passe à la prochaine entrée

	iny
	lda	(dpDATA),y	; 3 - nouveau numdes
	sta	numDESSIN
	iny
	lda	(dpDATA),y	; 4 - nouveau message
	sta	numMESSAGE
	iny
	lda	(dpDATA),y	; 5 - nouveau message système
	sta	numSYSTEMMESSAGE

initICONS2	lda	dpDATA	; prochaine entrée de tableau
	clc
	adc	#6
	sta	dpDATA
	lda	dpDATA+1
	adc	#0
	sta	dpDATA+1
	jmp	]lp

initICONS3	jsr	printSYSTEMMESSAGE	; affiche le nouveau message système (if any)
	jsr	printMESSAGE	; affiche le nouveau message (if any)
	jmp	chargeIMAGE	; charge la nouvelle image (if any)
	
*--------------------------------------
* direction
*
* Cherche dans le tableau de direction de l'image 'numdes' le numéro
* de l'image suivante grâce à l'index 'direc' (valeur entre 1 et 6)
* si 'direc'=1, on va au nord, 2=sud...
* le résultat est le numéro de l'image suivante
* mais si -1, c'est un sens interdit.
*--------------------------------------

direction
	jsr	getDESSINSITUATION
	bcc	direction0
	rts
	
direction0	pha			; le dessin courant

	lda	#2		; on veut le tableau des directions
	jsr	setDATA

	pla			; restaure
	sec
	sbc	#1
	beq	direction1

	tax			; on se sert du dessin comme index (index * 6)
	lda	#0		; on part de zéro alors
]lp	clc
	adc	#6
	dex
	bne	]lp		; en A, on ressort avec l'index de la ligne

direction1	clc
	adc	direc		; on lui ajoute la direction
	sec
	sbc	#1		; -1
	tay
	lda	(dpDATA),y		; on regarde dans la ligne du tableau
	cmp	#eod
	bne	direction3

direction2	lda	#7		; sens interdit !
	sta	numSYSTEMMESSAGE
	jsr	printSYSTEMMESSAGE
	
	lda	#0		; initialise le message
	sta	numSYSTEMMESSAGE	; pour ne rien afficher derrière
	lda	#chrRET2		; et met un retour chariot
	jmp	COUT

*--- Vérifie s'il y a une condition associée au déplacement

direction3	pha			; on a l'image cible

	lda	#16		; ici, on veut le tableau des déplacements sous conditions
	jsr	setDATA

	pla			; l'image visée
	pha
	sec			; -1
	sbc	#1
	tay
	lda	(dpDATA),y		; get the value from tblDeplacementsConditions
	cmp	#eod
	beq	direction4		; pas de condition à vérifier

*--- Vérifie si la condition est remplie

	tay
	dey			; -1
	pla			; restore A
	tax			; save in X
	lda	conditions,y		; check if condition is met
	bpl	direction2		; if not, we cannot move
	txa			; if met, we can move
	pha			; set room back in the stack
	
direction4	pla			; on récupère l'image et on sort
	sta	numDESSIN		; on a trouvé une nouvelle pièce
	sta	numMESSAGEIMAGE	; nouveau titre d'image
	rts

*--- Data

direc	ds	1	; la direction

*--------------------------------------
* attenteMOT
*
* Saisie d'un mot au clavier
*
*--------------------------------------

attenteMOT
	lda	#cursorCHAR
	sta	PROMPT	; force le prompt
	jsr	GETLNZ	; saisie d'un chaîne (on ne garde que 100 caractères)

	lda	TEXTBUFFER	; la chaîne est vide
	cmp	#chrRET2	; on ne traite que RET
	bne	attenteMOT2	; pour basculer l'affichage video
	jsr	switchVIDEO	; switch TEXT/DHGR
	clc		; loop now!
	rts
	
* La chaîne contient des caractères, on la transforme
* pour pouvoir l'analyser.
* Si elle dépasse 100 caractères, on tronque à 100 caractères

* Bon... le path ProDOS est écrasé... parfois !

attenteMOT2	cpx	lenMOT
	bcc	attenteMOT3
	ldx	lenMOT	; force à 100 caractères (dispensable)
attenteMOT3	stx	lenSTRING	; sauve la longueur
]lp	lda	TEXTBUFFER,x	; transforme la chaîne
	and	#andBIT7	; on vire le bit 7
	tay
	lda	tblSTRING,y	; en minuscules
	sta	mySTRING,x
	dex
	bpl	]lp
	sec		; we have a woorrrddd
	rts

*------------- My CSWL
*
*myCSWL
*	bit	$c061
*	bpl	myCSWL9
*	
*	pha
*	jsr	switchVIDEO
*	pla
*	nop
*	nop
*	nop
*	nop
*	nop
*	
*myCSWL9	jmp	(oldCSWL)

*--------------------------------------
* analyse
*
* La routine centrale qui vérifie
* les mots saisis par le joueur
* dans un dictionnaire
*
*--------------------------------------

analyse	stx	maxDICO	; le nombre d'entrées du dictionnaire
	sta	theDICO	; le dictionnaire choisi
	jsr	setDATA

* Etape 1 - On découpe la chaîne en mots
* Etape 2 - On vérifie la présence des mots dans le dictionnaire choisi

*------------------
* Etape 1
*------------------

	lda	#eod	; put #$FF
	sta	listeMOTS	; to ease the work of
	sta	listeMOTS+1	; the comparaison routine
	sta	listeMOTS+2	; dico must not have #$FF words then!
	
	ldx	#0
	stx	idxSTRING	; index dans la chaîne source
	stx	numMESSAGE	; on initialise pour savoir quoi afficher
	stx	numSYSTEMMESSAGE	; à la fin de l'analyse

* La grande boucle (vas-y Poupou)

analyse10	stx	idxMOTS	; nombre de mots trouvés
	cpx	#3	; nombre de mots max, trois ici
	bcs	analyse80	; on sort de notre chaîne et on traite

* La moyenne boucle

analyse20	ldx	idxSTRING	; index courant de X
	cpx	lenMOT	; si on arrive ici et qu'on est en fin de chaîne
	bcs	analyse80	; on sort de notre chaîne et on traite
	cpx	lenSTRING	; ici aussi
	bcs	analyse80
	
*--- On doit trouver le premier vrai caractère

]lp	lda	mySTRING,x
	cmp	#chra	; on lit un 'a'
	bcc	analyse40	; si <, on continue
	cmp	#chrz+1	; ou un 'z'+1
	bcc	analyse60	; alors, on a un caractère
	
analyse40	inx		; on n'a toujours pas de vrai caractère
	cpx	lenSTRING	; arrive-t-on à la fin de la chaîne ?
	bcs	analyse50
	cpx	lenMOT	; ou une chaîne de 100 caractères...
	bcc	]lp	; DEBUG was BNE

analyse50	sec		; on n'a aucun caractère texte dans la chaîne
	rts
	
*--- On doit trouver le dernier vrai caractère

analyse60	ldy	#0
]lp	lda	mySTRING,x
	cmp	#chrSPC	; on sort avec un espace
	beq	analyse70
	cmp	#chrDOT	; ou un point
	beq	analyse70
	cmp	#chrQM	; ou un point d'interrogation
	beq	analyse70
	sta	myWORD,y	; sauve le caractère du mot
	iny		; longueur du mot + 1
	inx
	cpx	lenSTRING	; arrive-t-on à la fin de la chaîne ?
	beq	analyse70
	cpx	lenMOT	; ou une chaîne de 100 caractères...
	bne	]lp

analyse70	inx
	stx	idxSTRING	; sauve l'index courant de X
	sty	lenWORD	; sauve la longueur du mot

	jsr	chercheMOT	; va-t-on trouver le mot dans le dictionnaire ?
	bcs	analyse20	; on n'a pas trouvé ! On boucle dans la chaîne

	ldx	idxMOTS	; on sauve le mot trouvé
	sta	listeMOTS,x	; dans la liste des mots trouvés
	inx
	bne	analyse10	; et on boucle

analyse80	rts		; now, check the situations

*--------------------------------------
* chercheMOT
*
* On vérifie la présence d'un mot saisi
* dans le dictionnaire fourni
*
*--------------------------------------

chercheMOT

* on boucle de 1 à maxDICO
* à la recherche des mots

	lda	#0
	sta	indexDICO
	
* en entrée, il faut un mot que l'on compare
* avec toutes les entrées du dictionnaire

mainLOOP
	inc	indexDICO	; on va pointer sur les mots
	lda	indexDICO	; du dictionnaire d'entrée indexDICO
	cmp	maxDICO	; nombre max d'entrées
	bcc	mainLOOP1
	sec		; on n'a pas trouvé le mot
	rts		; saisi dans l'ensemble du dictionnaire
	
mainLOOP1
	lda	indexDICO	; on prend le pointeur vers le début des mots
	jsr	setPOINTER	; in dpFROM

	lda	dpFROM	; et on sauve
	sta	dpDICOSTART
	lda	dpFROM+1
	sta	dpDICOSTART+1
	
	lda	indexDICO	; pareil pour l'entrée d'après
	clc
	adc	#1
	jsr	setPOINTER	; in dpFROM

	lda	dpFROM	; et on sauve
	sta	dpDICOEND
	lda	dpFROM+1
	sta	dpDICOEND+1
	
* on a l'adresse du premier mot d'une entrée de dictionnaire
* dans dpDICOSTART

* 7bonjour = 8
* 7bonjour = 8

innerLOOP
	ldy	#0		; on n'aura jamais de mot de longueur 0
]lp	lda	lenWORD,y		; on commence par la longueur de la chaîne
	cmp	(dpDICOSTART),y
	bne	nextMOT
	iny
	cpy	lenWORD		; ce sera la longueur
	bcc	]lp
	beq	]lp

* ici, on a trouvé le mot, son index est dans index1
* c'est ce que l'on retourne

	lda	indexDICO		; indique qu'on a trouvé le mot
	sec
	sbc	#1		; on retire 1 à cause du tableau des cas !
	clc			; on a trouvé le mot
	rts
	
* on n'a pas trouvé le mot alors on passe au mot suivant
* de l'entrée du dictionnaire.
* condition de sortie :
* - dpDICOSTART = dpDICOEND

nextMOT	ldy	#0	; on prend la longueur du mot dans le dictionnaire
	lda	(dpDICOSTART),y
	clc
	adc	#1	; +1 pour la longueur de la chaîne
	adc	dpDICOSTART	; +@ courant
	sta	dpDICOSTART	; on sauve l'adresse basse
	lda	dpDICOSTART+1	
	adc	#0
	sta	dpDICOSTART+1	; et l'adresse haute

nextMOT1	lda	dpDICOSTART+1	; est-on arrivé à la fin
	cmp	dpDICOEND+1	; des entrées du dictionnaire ?
	bcc	nextMOT2
	
	lda	dpDICOSTART	; même chose pour l'adresse basse
	cmp	dpDICOEND
	bcc	nextMOT2

* ici, on n'a pas trouvé de correspondance entre
* les mots d'une entrée de dictionnaire et le mot saisi
* et on a parcouru l'ensemble des entrées de l'index du dictionnaire
	
	jmp	mainLOOP
			
* ici, on n'a pas trouvé de correspondance entre
* les mots d'une entrée de dictionnaire et le mot saisi
* mais on n'a pas parcouru l'ensemble des entrées de l'index du dictionnaire

nextMOT2	jmp	innerLOOP

*--- Data

theDICO	ds	1	; quel est le dictionnaire actif ?
maxDICO	ds	1	; taille du dictionnaire
indexDICO	ds	1	; index en cours

*--------------------------------------
* getDECIMAL
*
* Transforme une valeur hexa en dec
*
*--------------------------------------

getDECIMAL
	ldx	#0	; valeur de sortie
]lp	stx	valDEC
	
	cmp	#10	; <10 ?
	bcc	getDECIMAL1	; on sort
	sec		; on enlève 10
	sbc	#10
	bmi	getDECIMAL1
	pha		; sauve
	txa
	clc
	adc	#$10	; on ajoute #$10
	tax
	pla		; restaure
	jmp	]lp

getDECIMAL1	clc		; on ajoute le reste < 10
	adc	valDEC
	sta	valDEC
	rts		; et on retourne la valeur

*--- Data

valDEC	ds	1	; on se limite à 0-99

*--------------------------------------
* printSYSTEMMESSAGE
*
* Affiche un message système
* Un message, c'est une chaîne C
*
*--------------------------------------

printSYSTEMMESSAGE
	lda	#7		; ici, on veut les messages du moteur
	jsr	setDATA

	lda	numSYSTEMMESSAGE	; Un message d'index 0 n'est pas affiché
	bne	printMESSAGEIMAGE1	; Jump to the next code!
	rts

*--------------------------------------
* printMESSAGEIMAGE
*
* Affiche un message du jeu
* Un message, c'est une chaîne C
*
*--------------------------------------

printMESSAGEIMAGE
	lda	#10		; ici, on veut le nom des lieux du jeu
	jsr	setDATA

	lda	numMESSAGEIMAGE	; Un message d'index 0 n'est pas affiché
	bne	printMESSAGEIMAGE1	; On saute au code d'après !
	rts

printMESSAGEIMAGE1
	jsr	setPOINTER		; calcule l'adresse de la chaîne
	jmp	printCSTRING		; affiche le texte
	
*--------------------------------------
* printMESSAGE
*
* Affiche un message du jeu
* Un message, c'est une chaîne C
*
*--------------------------------------

printMESSAGE
	lda	#11		; ici, on veut les messages du jeu
	jsr	setDATA

	lda	numMESSAGE		; Un message d'index 0 n'est pas affiché
	bne	printMESSAGEIMAGE1
	rts

*--------------------------------------
* printDIALOGUE
*
* Affiche un dialogue du jeu
* Un dialogue, c'est :
* - str
* - str
* - cstring
*
*--------------------------------------

printDIALOGUE
	lda	#12		; ici, on veut les dialogues du jeu
	jsr	setDATA

	lda	numDIALOGUE	; Un message d'index 0 n'est pas affiché
	bne	printDIALOGUE1
	rts

printDIALOGUE1
	jsr	setPOINTER	; dpFROM pointe sur la 1ère STRING
	
	ldx	dpFROM+1
	ldy	dpFROM
	jsr	printSTRING2	; affiche une chaîne Pascal (par X et Y)
	jsr	calcNEXTSTRING	; pointe sur la prochaine chaîne

	lda	dpFROM		; on sauvegarde dpFROM
	sta	dpTO
	lda	dpFROM+1
	sta	dpTO+1
	jsr	calcNEXTSTRING	; pointe sur la chaîne C
	jsr	CROUT		; always output a CR
	jsr	printCSTRING

	jsr	CROUT		; always output a CR
	ldx	dpTO+1		; Imprime la dernière chaîne Pascal
	ldy	dpTO		; Originellement, c'était le texte du bouton
	jmp	printSTRING2	; sur la version Mac
	
*--------------------------------------
* printSTRING
*
* Affiche une chaîne Pascal
* Source: dpFROM
*
*--------------------------------------

printSTRING
	ldy	#0		; récupère la longueur de la chaîne
	lda	(dpFROM),y
	beq	printSTRING5	; une chaîne nulle, on sort
	sta	lenSTR
	
]lp	jsr	printSTRING5	; prochain caractère
	ldy	#0
	lda	(dpFROM),y
	ora	#maskBIT7
	jsr	COUT		; affiche le caractère
	
	dec	lenSTR	; un caractère de moins à afficher
	bne	]lp		; boucle ou sort
	
printSTRING5			; le prochain caractère
	inc	dpFROM
	bne	printSTRING9
	inc	dpFROM+1
printSTRING9
	rts

*--- Data

lenSTR	ds	1	; longueur de ma chaîne interne

*--------------------------------------
* printSTRING2
*
* Affiche une chaîne Pascal
* Source: X/Y
*
*--------------------------------------

printSTRING2
	sty	dpWORK		; sauve le pointeur de chaîne
	stx	dpWORK+1

	ldy	#0		; récupère la longueur de la chaîne
	lda	(dpWORK),y
	beq	printSTRING25	; une chaîne nulle, on sort
	sta	lenSTR
	
]lp	jsr	printSTRING25	; prochain caractère
	ldy	#0
	lda	(dpWORK),y
	ora	#maskBIT7
	jsr	COUT		; affiche le caractère
	
	dec	lenSTR	; un caractère de moins à afficher
	bne	]lp		; boucle ou sort
	
printSTRING25			; le prochain caractère
	inc	dpWORK
	bne	printSTRING29
	inc	dpWORK+1
printSTRING29
	rts
	
*--------------------------------------
* printCSTRING
*
* Affiche une chaîne C
* Source: dpFROM
*
*--------------------------------------

printCSTRING
]lp	ldy	#0		; affiche un caractère
	lda	(dpFROM),y
	beq	printCSTRING5	; sauf s'il est nul
	ora	#maskBIT7
	jsr	COUT		; affiche le caractère

	jsr	printCSTRING5	; next char
	jmp	]lp		; loop
	
printCSTRING5			; le prochain caractère
	inc	dpFROM
	bne	printCSTRING9
	inc	dpFROM+1
printCSTRING9
	rts

*--------------------------------------
* printCSTRING2
*
* Affiche une chaîne C
* Source: X/Y
*
*--------------------------------------

printCSTRING2
	sty	dpWORK		; sauve le pointeur de chaîne
	stx	dpWORK+1

	lda	#chrRET		; always output a CR
	jsr	COUT
	
]lp	ldy	#0		; affiche un caractère
	lda	(dpWORK),y
	beq	printCSTRING25	; sauf s'il est nul
	ora	#maskBIT7
	jsr	COUT		; affiche le caractère

	jsr	printCSTRING25	; next char
	jmp	]lp		; loop
	
printCSTRING25			; le prochain caractère
	inc	dpWORK
	bne	printCSTRING29
	inc	dpWORK+1
printCSTRING29
	rts
	
*--------------------------------------
* Les routines ProDOS sont ici
*--------------------------------------

*--------------------------------------
* chargeIMAGE
*
* Charge une image en mémoire
*
*--------------------------------------

chargeIMAGE
	lda	fgTEXTE	; est-on en mode texte forcé ?
	bmi	chargeIMAGE1	; oui, sort
	lda	dataPICTURES	; do we have pictures?
	bpl	chargeIMAGE2	; v1.3 - yes (BNE to BPL)
chargeIMAGE1	rts

*
*--- Alternate entry point: you provide the image number
*

chargeIMAGEALT	tax		; save the image number
	lda	dataPICTURES	; do we have pictures?
	bmi	chargeIMAGE1	; v1.3 - no (BEQ to BMI)
	lda	fgTEXTE	; est-on en mode texte forcé ?
	bmi	chargeIMAGE1	; oui, sort
	txa		; yes
	jmp	chargeIMAGE3	; load it please

*
*--- Charge une image
*

chargeIMAGE2	lda	numDESSIN
chargeIMAGE3	jsr	getDECIMAL	; get the decimal value
	pha
	and	#%11110000	; keep four 4 bits
	lsr
	lsr
	lsr
	lsr
	ora	#'0'	; add 0
	sta	pIMAGE+11
	pla
	and	#%00001111	; same for the 4 lower bits
	ora	#'0'
	sta	pIMAGE+12
	
	jsr	openIMAGE	; 1 - open the image
	bcc	chargeIMAGE4
	rts

*
*--- Format of the image?
*

chargeIMAGE4	lda	picCOMPRESSION	; quel format pour les images ?
	cmp	#compUNSUPPORTED
	bcs	chargeIMAGE9	; unsupported
	asl
	tax
	lda	tblPICCOMP,x
	sta	chargeIMAGE5+1
	lda	tblPICCOMP+1,x
	sta	chargeIMAGE5+2

chargeIMAGE5	jsr	$bdbd	; traite le format
	php
	jsr	closeIMAGE	; 3 - close the image
	plp

* Olivier does not want the image to be displayed by default once loaded
	rts

*	bcs	chargeIMAGE9	; handle error
*	
*	lda	#true	; force l'affichage des images
*	sta	fgVIDEO	; 
*	jmp	switchVIDEOALT

chargeIMAGE9	jmp	closeIMAGE	; error!

*--- Data

tblPICCOMP			; c'est la table des routines image
	da	picNONE	; ok
	da	picLZ4	; ok

*--------------------------------------
* Les routines de chargement des images
* non compressées
*
*--------------------------------------

picNONE	lda	dataPICTURES	; quel format pour les images ?
	bmi	picNONE9	; v1.3 - no pics
	cmp	#picUNSUPPORTED
	bcs	picNONE9	; unsupported
	sec
	sbc	#1
	asl
	tax
	lda	tblPICNONE,x
	sta	picNONE1+1
	lda	tblPICNONE+1,x
	sta	picNONE1+2
picNONE1	jsr	$bdbd	; carry tells
picNONE9	rts
	
*
*--- Data
*

tblPICNONE
	da	picNONE40	; 0001 - 40
	da	picNONE80	; 0010 - 80
	da	picNONE40	; 0011 - GR
	da	picNONE80	; 0100 - DGR
	da	picNONEHGR	; 0101 - HGR
	da	picNONEHGR	; 0110 - HGR MONO
	da	picNONEDHGR	; 0111 - DHGR
	da	picNONEDHGR	; 1000 - DHGR MONO
	da	picNONESHR	; 1001 - SHR
	da	picNONESHR	; 1010 - SHR

*--------------
* Sub-routines
*--------------

picNONE80	ldx	#>ptrIMAGE80	; load $400 bytes at $2400
	ldy	#4
	jsr	readIMAGEALT	; and continue below...

picNONE40	ldx	#>ptrIMAGE	; load $400 bytes at $2000
	ldy	#4
	jmp	readIMAGEALT

picNONEDHGR	jsr	picNONEHGR	; load $2000 bytes at $2000
	jsr	moveTOAUX	; move to aux memory
	
picNONEHGR	ldx	#>ptrIMAGE	; load $2000 bytes at $2000
	ldy	#$20
	jmp	readIMAGEALT

picNONESHR	sec
	jsr	IDROUTINE
	bcc	picNONESHR1	; CLC means a IIgs!
	rts
picNONESHR1	lda	#>ptrIMAGE	; init starting address
	sta	moveTOSHR1+2
	jsr	picNONEHGR	; load $2000
	bcs	picNONESHR9
	jsr	moveTOSHR	
	jsr	picNONEHGR	; load $2000
	bcs	picNONESHR9
	jsr	moveTOSHR
	jsr	picNONEHGR	; load $2000
	bcs	picNONESHR9
	jsr	moveTOSHR
	jsr	picNONEHGR	; load $2000
	bcs	picNONESHR9
	jsr	moveTOSHR
picNONESHR9	rts
	
*---
	
moveTOAUX	lda	#<ptrIMAGE
	sta	A1L
	sta	A4L
	lda	#>ptrIMAGE
	sta	A2H
	sta	A4H
	lda	#$ff
	sta	A2L
	lda	#$3f
	sta	A2H
	sec
	jmp	AUXMOVE

moveTOSHR	clc		; 16-bit
	xce
	rep	#$30
	ldx	#$2000-2	; move 8192 bytes
]lp	lda	ptrIMAGE,x
moveTOSHR1	stal	$e12000,x
	dex
	dex
	bpl	]lp
	
	lda	moveTOSHR1+1	; next $2000
	clc
	adc	#$2000
	sta	moveTOSHR1+1
	sec
	xce
	sep	#$30
	rts

*--------------------------------------
* Les routines de chargement des images
* compressées
*
*--------------------------------------

picLZ4	lda	dataPICTURES	; quel format pour les images ?
	bmi	picLZ49	; v1.3 - no pics
	cmp	#picUNSUPPORTED
	bcs	picLZ49	; unsupported
	sec
	sbc	#1
	asl
	tax
	lda	tblPICLZ4,x
	sta	picLZ41+1
	lda	tblPICLZ4+1,x
	sta	picLZ41+2
	
	ldx	#>loadBUFFER	; load 8 pages at $B000
	ldy	#8
	jsr	readIMAGEALT
	jsr	initLZ4	; init the unpacker code
	
picLZ41	jsr	$bdbd	; now unpack please
picLZ49	rts
	
*
*--- Data
*

tblPICLZ4
	da	picLZ440	; 0001 - 40
	da	picLZ480	; 0010 - 80
	da	picLZ440	; 0011 - GR
	da	picLZ480	; 0100 - DGR
	da	picLZ4HGR	; 0101 - HGR
	da	picLZ4HGR	; 0110 - HGR MONO
	da	picLZ4DHGR	; 0111 - DHGR
	da	picLZ4DHGR	; 1000 - DHGR MONO
	da	picLZ4SHR	; 1001 - SHR
	da	picLZ4SHR	; 1010 - SHR

*--------------
* Sub-routines
*--------------

picLZ440	ldx	#>ptrIMAGE80	; buffer is $2000..$23FF
	ldy	#<ptrIMAGE80
	lda	#>ptrIMAGE
	jsr	unpackLZ4
	clc
	rts

picLZ480	ldx	#>ptrPAGE2800	; buffer is $2000..$27FF
	ldy	#<ptrPAGE2800	; because main RAM first
	lda	#>ptrIMAGE	; and aux RAM second
	jsr	unpackLZ4
	
	ldy	#0	; now invert the two buffers!
]lp	ldx	ptrIMAGE,y
	lda	ptrIMAGE+$0400,y
	sta	ptrIMAGE,y
	txa
	sta	ptrIMAGE+$0400,y
	ldx	ptrIMAGE+$0100,y
	lda	ptrIMAGE+$0500,y
	sta	ptrIMAGE+$0100,y
	txa
	sta	ptrIMAGE+$0500,y
	ldx	ptrIMAGE+$0200,y
	lda	ptrIMAGE+$0600,y
	sta	ptrIMAGE+$0200,y
	txa
	sta	ptrIMAGE+$0600,y
	ldx	ptrIMAGE+$0300,y
	lda	ptrIMAGE+$0700,y
	sta	ptrIMAGE+$0300,y
	txa
	sta	ptrIMAGE+$0700,y
	iny
	bne	]lp
	clc
	rts

picLZ4HGR	ldx	#>ptrPAGE4000	; buffer is $2000..$3FFF
	ldy	#<ptrPAGE4000
	lda	#>ptrIMAGE
	jsr	unpackLZ4
	clc
	rts

picLZ4DHGR	ldx	#>ptrPAGE4000	; buffer is $0000..$1FFF
	ldy	#<ptrPAGE4000
	lda	#>ptrIMAGE
	jsr	unpackLZ4
	
	jsr	moveTOAUX	; move $2000..$3FFF to zux RAM

	lda	#>ptrIMAGE	; buffer is $2000..$3FFF
	jsr	unpackLZ4ALT
	clc
	rts

picLZ4SHR	sec
	jsr	IDROUTINE
	bcc	picLZ4SHR1	; CLC means a IIgs!
	rts
picLZ4SHR1	lda	#>ptrIMAGE	; init starting address
	sta	moveTOSHR1+2

	ldx	#>ptrPAGE4000	; load $0000..$1FFF
	ldy	#<ptrPAGE4000
	lda	#>ptrIMAGE
	jsr	unpackLZ4
	jsr	moveTOSHR
	lda	#>ptrIMAGE	; load $2000..$3FFF
	jsr	unpackLZ4ALT
	jsr	moveTOSHR
	lda	#>ptrIMAGE	; load $4000..$5FFF
	jsr	unpackLZ4ALT
	jsr	moveTOSHR
	lda	#>ptrIMAGE	; load $6000..$7FFF
	jsr	unpackLZ4ALT
	jsr	moveTOSHR
	clc
	rts

*--------------------------------------
* unpackLZ4
*
* Unpack a LZ4 image
* Code by Peter Ferrie
* Used with permission
* Adapted for the game engine
*
*--------------------------------------

src	=	$0	; zero page usage
dst	=	src+2

*-------------
* init vars
*-------------

initLZ4SRC	lda	#<loadBUFFER	; set the pointer to the packed data
	sta	src
	lda	#>loadBUFFER
	sta	src+1
	ldy	#0	; our index is 0
	rts

initLZ4	jsr	initLZ4SRC	; set the pointer
	ldy	#4	; read unpacked length
	lda	(src),y
	sta	length
	iny
	lda	(src),y
	sta	length+1

	lda	src
	clc
	adc	#16	; size of the header
	sta	src
	lda	src+1
	adc	#0
	sta	src+1
	
	ldy	#0	; our index is 0
	rts
	
*-------------
* unpacker
*-------------

unpackLZ4ALT	sta	dst+1	; reset destination address
	ldy	#0	; end does not change
	sty	dst
	jmp	parsetoken	; for files larger than buffer
	
unpackLZ4	sty	end	; set the end address of 
	stx	end+1	; the destination buffer
	sta	dst+1	; where to unpack
	lda	#0	; always 0
	sta	dst

	jsr	initLZ4	; make inits

parsetoken	jsr	getsrc
	pha
	lsr
	lsr
	lsr
	lsr
	beq	copymatches
	jsr	buildcount
	tax
	jsr	docopy

*	lda	src	; did we reach the end?
*	cmp	end
*	lda	src+1
*	sbc	end+1
*	bcs	done

	lda	dst	; did we reach the end?
	cmp	end
	lda	dst+1
	sbc	end+1
	bcs	done

copymatches	jsr	getsrc
	sta	delta
	jsr	getsrc
	sta	delta+1
	pla
	and	#$0f
	jsr	buildcount
	clc
	adc	#4
	tax
	bcc	copymatches1
	inc	count+1
copymatches1	lda	src+1
	pha
	lda	src
	pha
	sec
	lda	dst
	sbc	delta
	sta	src
	lda	dst+1
	sbc	delta+1
	sta	src+1
	jsr	docopy
	pla
	sta	src
	pla
	sta	src+1
	jmp	parsetoken

done	pla		; yes, exit!
	rts

*---

docopy	jsr	getput
	dex
	bne	docopy
	dec	count+1
	bne	docopy
	rts

*---

buildcount	ldx	#1
	stx	count+1
	cmp	#$0f
	bne	buildcount2
]lp	sta	count
	jsr	getsrc
	tax
	clc
	adc	count
	bcc	buildcount1
	inc	count+1
buildcount1	inx
	beq	]lp
buildcount2	rts

*---

getput	jsr	getsrc

putdst	sta 	(dst), y
	inc	dst
	bne	putdst1
	inc	dst+1
putdst1	rts

*---

getsrc	lda 	(src), y
	pha		; save read value
	inc	src
	bne	getsrc1
	inc	src+1
	
	lda	src+1	; did we reach the end
	cmp	#>proBUFFER	; of the read buffer?
	bcc	getsrc1
	lda	src
	cmp	#<proBUFFER
	bcc	getsrc1
	jsr	readIMAGE	; reload the buffer
	jsr	initLZ4SRC	; init SRC pointer

getsrc1	pla
	rts

*--- Data

end	ds	2
count	ds	2
delta	ds	2
length	ds	2

*--------------------------------------
* openIMAGE
*
* Ouvre une image en mémoire
* Les paramètres sont déjà mis en place
*
*--------------------------------------

openIMAGE
	jsr	beforeDA	; call the hook routine
	
	lda	#<pIMAGE	; quoi
	sta	proOPEN+1
	lda	#>pIMAGE
	sta	proOPEN+2

	jsr	PRODOS	; open it
	dfb	$c8
	da	proOPEN
	bcc	openIMAGE1
	sta	proERR
	
	jsr	afterDA	; call the hook routine

	lda	#samegame	; on continue, le fichier n'existe pas
	sec
	rts

openIMAGE1	lda	proOPEN+5	; set the file ID
	sta	proGETEOF+1
	sta	proREAD+1
	sta	proCLOSE+1

	jsr	PRODOS	; get the file length
	dfb	$d1
	da	proGETEOF
	rts

*
*--- Read data from the image
*

readIMAGEALT
	stx	proREAD+3	; address (high pointer)
	sty	proREAD+5	; length (number of pages)
	lda	#0	; low address & buffer are 0
	sta	proREAD+2
	sta	proREAD+4

readIMAGE
	jsr	PRODOS	; read data from file
	dfb	$ca
	da	proREAD
	sta	proERR
	rts

*
*--- Close the image file
*

closeIMAGE
	jsr	PRODOS	; close file
	dfb	$cc
	da	proCLOSE

	jsr	afterDA	; call the hook routine

	clc		; force le tout va bien
	rts
	
*--- Data

pIMAGE	str	'DATA/IMAGEXX'	; XX = index 11

*--------------------------------------
* loadPARTIE
*
* Charge une partie en mémoire
* Les paramètres sont déjà mis en place
*
*--------------------------------------

loadPARTIE
	jsr	beforeDA	; call the hook routine

	jsr	PRODOS	; open it
	dfb	$c8
	da	proOPEN
	bcc	loadPARTIE1
	sta	proERR

	jsr	afterDA	; call the hook routine
	
loadPARTIE0	lda	#samegame	; on continue, le fichier n'existe pas
	sec
	rts

loadPARTIE1	lda	proOPEN+5	; zou, on prend l'ID
	sta	proREAD+1
	sta	proCLOSE+1
	
	jsr	PRODOS	; on charge le fichier
	dfb	$ca
	da	proREAD
	sta	proERR
	
	lda	proREAD+6	; a-t-on lu des octets ?
	ora	proREAD+7
	bne	loadPARTIE2	; oui

	jsr	loadPARTIE3	; non, on le ferme
	jmp	loadPARTIE0	; et on continue de jouer
	
loadPARTIE2	lda	proREAD+4	; on a un peu lu
	cmp	proREAD+6	; mais pas suffisamment
	bne	loadPARTIEERR
	lda	proREAD+5
	cmp	proREAD+7
	bne	loadPARTIEERR
	
loadPARTIE3	jsr	PRODOS	; on le ferme
	dfb	$cc	; tout va bien !
	da	proCLOSE
	
	jsr	afterDA	; call the hook routine

	clc		; force le tout va bien
	rts

loadPARTIEERR	jsr	loadPARTIE3	; déjà, on ferme le fichier
	lda	#newgame	; on n'a pas suffisament lu d'octets
	sec		; on doit partir sur un nouveau jeu !
	rts
	
*--------------------------------------
* savePARTIE
*
* Sauve une parie en mémoire
* Les paramètres sont déjà mis en place
*
*--------------------------------------

savePARTIE
	jsr	beforeDA	; call the hook routine

	jsr	PRODOS
	dfb	$c0
	da	proCREATE

	jsr	PRODOS
	dfb	$c8
	da	proOPEN
	bcc	savePARTIE1
	sta	proERR

	jsr	afterDA	; call the hook routine

	sec
	rts

savePARTIE1	lda	proOPEN+5	; zou, on prend l'ID
	sta	proWRITE+1
	sta	proCLOSE+1
	
	jsr	PRODOS	; on sauve le fichier
	dfb	$cb
	da	proWRITE
	sta	proERR
	
	php		; on sauve l'état
	jsr	PRODOS	; on le ferme
	dfb	$cc
	da	proCLOSE

	jsr	afterDA	; call the hook routine

	plp		; on le restaure
	rts

*--- Data

proERR	ds	1	; erreur ProDOS rencontrée

proCREATE	dfb	$7
	da	pPARTIE
	dfb	$e3	; access
	dfb	$06	; file_type (bin)
	dw	$bdbd	; aux_type
	ds	1	; storage_type
	ds	2	; create_date
	ds	2	; create_time
	
proOPEN	dfb	$3
	ds	2	; pathname
	da	proBUFFER	; io_buffer
	ds	1	; ref_num

proREAD			; les deux partagent...
proWRITE			; ...les mêmes paramètres
	dfb	$4
	ds	1	; ref_num
	ds	2	; data_buffer
	ds	2	; request_count
	ds	2	; transfer_count

proCLOSE	dfb	$1
	ds	1	; ref_num

proGETEOF	dfb	$2
	ds	1	; ref_num
	ds	3	; eof

*--------------------------------------
* initTEXT
*
* Se met en mode 80 colonnes ou pas
* et vérifie les pré-requis du jeu
* par rapport à l'ordinateur utilisé
*
*--------------------------------------

initTEXT
	lda	dataTEXT	; le jeu est-il en 80 colonnes ?
	cmp	#text80COL
	bne	initTEXT2	; non, tout va bien
	
	lda	MACHID	; oui, il l'est mais a-t-on 80 colonnes ?
	and	#mask80COL
	bne	initTEXT1	; oui

initTEXT0	lda	#13	; il faut une carte 80-colonnes a minima
	sta	numSYSTEMMESSAGE
	jsr	printSYSTEMMESSAGE
	sec		; retour en erreur
	rts
	
initTEXT1	jsr	$C300	; on se met en 80-colonnes

initTEXT2	lda	#sizeMOT	; une chaîne de caractères, c'est 100 caractères au maximum
	sta	lenMOT
	
	jsr	INIT	; text screen
	jsr	SETNORM	; set normal text mode
	jsr	SETKBD	; reset input to keyboard
	jsr	HOME	; home cursor and clear to end of page

*--- Forcer le mode d'affichage texte/image

	lda	#true	; on veut le texte par défaut
	sta	fgTEXTE

*--- Olivier veut mieux gérer le RC sur les images
*
*	lda	CSWL
*	sta	oldCSWL
*	lda	CSWH
*	sta	oldCSWL+1
*
*	lda	#<myCSWL
*	sta	CSWL
*	lda	#>myCSWL
*	sta	CSWH
	
*--- Peut-on gérer les images 80-col et DGR ?

	lda	dataPICTURES	; Les images sont en 80-col ou DGR ?
	cmp	#picTEXT80
	beq	initTEXT3
	cmp	#picDGR
	bne	initTEXT4

initTEXT3	lda	MACHID	; Oui, a-t-on une carte 80-colonnes
	and	#mask80COL
	beq	initTEXT5	; non, on n'affichera pas d'image

*--- et les images DHGR ?

initTEXT4	lda	dataPICTURES	; Les images sont en DHGR ?
	cmp	#picDHGR
	beq	initTEXT5
	cmp	#picDHGRMONO
	bne	initTEXT6
	
	lda	MACHID	; do we have 128K?
	and	#mask128K	; useful for DHGR pictures
	cmp	#mask128K
	beq	initTEXT6	; yes, we have

initTEXT5	lda	#picNOPICS	; we cannot display
	sta	dataPICTURES	; 64K pictures, sorry!

initTEXT6	lda	dataPICTURES	; au final, a-t-on des images ?
	bmi	initTEXT9	; v1.3 - non (BEQ to BMI)

	lda	#false	; alors, on met des images par défaut
	sta	fgTEXTE

initTEXT9	clc		; we are good
	rts

*--- Data
*
*oldCSWL	ds	2	; pointer to char output

*--------------------------------------
* switchVIDEO
*
* Echange le mode texte/graphique
*
*--------------------------------------

switchVIDEO
	lda	dataPICTURES	; do we have pictures?
	bpl	switchVIDEOALT	; v1.3 - yes, handle the format (BNE to BPL)
	rts

switchVIDEOTER			; point d'entrée tertiaire
	sta	fgVIDEO	; avec le flag video donné
	
switchVIDEOALT	lda	fgTEXTE	; est-on en mode forcé ?
	bmi	switch2TEXT

	lda	fgVIDEO	; 0 : graphique
	eor	#true	; 1 : texte
	sta	fgVIDEO
	bne	switch2TEXT

	jmp	switch2GFX	; now, handle the display

*--------------------------------------
* switch2TEXT
*
* Set the text mode
* For TEXT and GR modes, we must
* restore the previous data
*
*--------------------------------------

switch2TEXT	lda	dataPICTURES	; test if TEXT or GR/DGR
	bmi	switch2TEXTA	; v1.3 - no pics
	cmp	#picHGR
	bcs	switch2TEXT9	; nope, switch to text now

	and	#%00000001	; keep bit 0 for 40 or GR
	beq	switch2TEXT1	; only 40-col, no aux mem

	lda	#<proBUFFER	; restore the aux memory
	sta	A1L
	sta	A4L
	lda	#>proBUFFER	; at $2400
	clc
	adc	#4
	sta	A1H
	lda	#$04	; text screen
	sta	A4H
	lda	#$ff	; end source
	sta	A2L
	lda	#>proBUFFER	; merlin limitation
	clc		; I would have liked to
	adc	#7	; type in #>proBUFFER+7
	sta	A2H
	sec		; from main to aux
	jsr	AUXMOVE
	
switch2TEXT1	ldx	#0	; restore the text screen
]lp	lda	proBUFFER,x
	sta	$400,x
	lda	proBUFFER+$100,x
	sta	$500,x
	lda	proBUFFER+$200,x
	sta	$600,x
	lda	proBUFFER+$300,x
	sta	$700,x
	inx
	bne	]lp
	
switch2TEXT9	sta	LORES	; mode TEXTE (40 ou 80 col)
	sta	TXTPAGE1
	sta	MIXSET
	sta	TXTSET

	sec
	jsr	IDROUTINE
	bcs	switch2TEXTA	; CLC means a IIgs!

	lda	#$01	; mode TEXTE sur IIgs
	sta	NEWVIDEO
switch2TEXTA	rts

*--------------------------------------
* switch2GFX
*
* Set the graphics mode
*
*--------------------------------------

switch2GFX	lda	dataPICTURES	; test if TEXT or GR/DGR
	bmi	switch2GFX9	; v1.3 - no pics
	cmp	#picHGR
	bcs	switch2GFX2	; nope, skip that part

	and	#%00000001	; keep bit 0 for 40 or GR
	bne	switch2GFX1	; only 40-col, no aux mem

	lda	#<proBUFFER	; save the aux memory
	sta	A1L
	sta	A4L
	lda	#$04	; text screen
	sta	A1H
	lda	#>proBUFFER	; at proBUFFER+$400
	clc
	adc	#4
	sta	A4H
	lda	#$ff	; end source
	sta	A2L
	lda	#$07
	sta	A2H
	clc		; from aux to main
	jsr	AUXMOVE
	
switch2GFX1	ldx	#0	; save the main text screen
]lp	lda	$400,x
	sta	proBUFFER,x
	lda	$500,x
	sta	proBUFFER+$100,x
	lda	$600,x
	sta	proBUFFER+$200,x
	lda	$700,x
	sta	proBUFFER+$300,x
	inx
	bne	]lp

*--- Now that memory is preserved if needed, switch to the right display

switch2GFX2	lda	dataPICTURES	; which display to use
	bmi	switch2GFX9	; v1.3 - no pics
	and	#%00001111
	cmp	#picUNSUPPORTED
	bcs	switch2GFX9
	sec
	sbc	#1
	asl		; *2
	tax
	lda	switchTBL,x	; get address of routine
	sta	switch2GFX3+1
	lda	switchTBL+1,x
	sta	switch2GFX3+2
switch2GFX3	jmp	$bdbd	; jump to it
switch2GFX9	rts

*
*--- Switch to 40-col picture
*

switchTEXT40	ldx	#0
]lp	lda	ptrIMAGE,x
	sta	$400,x
	lda	ptrIMAGE+$100,x
	sta	$500,x
	lda	ptrIMAGE+$200,x
	sta	$600,x
	lda	ptrIMAGE+$300,x
	sta	$700,x
	inx
	bne	]lp
	rts

*
*--- Switch to 80-col picture
*

switchTEXT80	lda	#<ptrIMAGE	; move to aux memory
	sta	A1L
	sta	A4L
	lda	#>ptrIMAGE	; at $2400
	clc
	adc	#4
	sta	A1H
	lda	#$04	; text screen
	sta	A4H
	lda	#$ff	; end source
	sta	A2L
	lda	#>ptrIMAGE	; merlin limitation
	clc		; I would have liked to
	adc	#7	; type in #>ptrIMAGE+7
	sta	A2H
	sec		; from main to aux
	jsr	AUXMOVE
	jmp	switchTEXT40
	
*
*--- Switch to GR picture
*

switchGR	jsr	switchTEXT40
switchGR2	sta	TXTCLR
	sta	MIXCLR
	sta	TXTPAGE1
	sta	LORES
	rts

*
*--- Switch to DGR picture
*

switchDGR	jsr	switchTEXT80	; DGR
	jsr	switchGR2	; activate GR
	ldx	#2	; activate DGR
]lp	sta	SET80COL	
	sta	CLRAN
	sta	CLR80VID
	sta	SETAN3
	sta	CLRAN3
	sta	SET80VID
	sta	SETAN3
	dex
	bne	]lp
	rts

*
*--- Switch to HGR color picture
*

switchHGR	sec
	jsr	IDROUTINE
	bcs	switchHGR2	; CLC means a IIgs!

	lda	#false	; force color
	sta	MONOCOLOR
	lda	NEWVIDEO	; color double-hires (do it here)
	and	#%11011111
	sta	NEWVIDEO
	
switchHGR2	sta	TXTCLR
	sta	MIXCLR
	sta	TXTPAGE1
	sta	HIRES
	rts

*
*--- Switch to HGR mono picture
*

switchHGRMONO	sec
	jsr	IDROUTINE
	bcs	switchHGR2	; CLC means a IIgs!

	lda	#true
	sta	MONOCOLOR
	lda	NEWVIDEO
	and	#%11011111
	ora	#%00100000
	sta	NEWVIDEO
	jmp	switchHGR2

*
*--- Switch to DHGR color picture
*

switchDHGR	jsr	switchHGR	; DHGR color
switchDHGR2	ldx	#2
]lp	sta	SET80COL	
	sta	CLRAN
	sta	CLR80VID
	sta	SETAN3
	sta	CLRAN3
	sta	SET80VID
	sta	SETAN3
	dex
	bne	]lp
	rts

*
*--- Switch to DHGR mono picture
*

switchDHGRMONO	jsr	switchHGRMONO
	jmp	switchDHGR2

*
*--- Switch to SHR picture
*

switchSHR	sec
	jsr	IDROUTINE
	bcs	switchSHR2	; CLC means a IIgs!

	lda	#$c1	; passe en SHR
	sta	NEWVIDEO
switchSHR2	rts
	
*--- Data

switchTBL	da	switchTEXT40
	da	switchTEXT80
	da	switchGR
	da	switchDGR
	da	switchHGR
	da	switchHGRMONO
	da	switchDHGR
	da	switchDHGRMONO
	da	switchSHR
	da	switchSHR
	
fgVIDEO	dfb	true	; switch texte dhgr quand on presse return

*--------------------------------------
* initGAME
*
* Initialisation des paramètres du jeu
*
*--------------------------------------

initGAME
	lda	fgINIT		; did we perform the init?
	bmi	initGAME1

	lda	dpDATA		; on récupère le pointeur où les données
	sta	ptrDATA
	lda	dpDATA+1
	sta	ptrDATA+1		; du jeu sont chargées
	lda	dpDATA+2
	sta	ptrDATA+2		; du jeu sont chargées

	lda	#true		; OK, we've done the init
	sta	fgINIT
	
initGAME1	lda	#1		; on enregistre le pointeur vers les data
	jsr	setDATA		; on veut tblGame
	
	ldy	#0		; on recopie tout tblGAME
]lp	lda	(dpDATA),y
	sta	dataVERSION,y
	iny
	cpy	#numSYSTEMMESSAGE-dataVERSION
	bcc	]lp

*---
	
	lda	imageTITRE	; image par défaut
	sta	numDESSIN
	sta	numMESSAGEIMAGE	; et son texte associé

	lda	messageTITRE	; message par défaut
	sta	numMESSAGE

	lda	dialogueTITRE	; dialogue par défaut
	sta	numDIALOGUE
	rts

*--- Data

fgINIT	ds	1	; true if already init'ed

*--------------------------------------
* setDATA
*
* Fixe le pointeur vers la zone indexée par A
*
* A=
*  1 - tblGame
*  2 = tblDirections
*  3 = tblCas
*  4 = tblCasImage
*  5 = tblConditions
*  6 = tblSituations
*  7 = tblSystemMessages (texte)
*  8 = tblSystemDictionnaire (texte)
*  9 = tblDictionnaire (texte)
* 10 = tblMessagesImage (texte)
* 11 = tblMessages (texte)
* 12 = tblDialogues (texte)
* 13 = tblConditionsImage
*
*--------------------------------------

setDATA
	sec
	sbc	#1	; -1
	asl		; *2
	asl		; *4
	tay		; in Y

	lda	ptrDATA	; On met le pointeur
	sta	dpDATA	; vers les données du jeu
	lda	ptrDATA+1
	sta	dpDATA+1
	lda	ptrDATA+2
	sta	dpDATA+2

	lda	(dpDATA),y	; Récupère l'adresse
	tax		; du pointeur de la table demandée
	iny		; et la sauvegarde
	lda	(dpDATA),y
	pha
	iny
	lda	(dpDATA),y
	sta	dpDATA+2
	pla
	sta	dpDATA+1
	stx	dpDATA

	lda	dpDATA	; from an offset to an address
	clc
	adc	ptrDATA
	sta	dpDATA
	lda	dpDATA+1
	adc	ptrDATA+1
	sta	dpDATA+1
	lda	dpDATA+2
	adc	ptrDATA+2
	sta	dpDATA+2
	
	ldy	dpDATA	; retourne le pointeur à l'appelant
	ldx	dpDATA+1	; 16b
	lda	dpDATA+2	; 24b
	rts

*--- Data

ptrDATA	ds	4	; pointeur réel (a long for later)

*--------------------------------------
* setPOINTER
*
* Fixe le pointeur vers le texte indexé par A
* Source est dpDATA (un tableau de pointeurs)
* Auquel on ajoute (A-1)*2 pour avoir le
* pointeur vers la chaîne recherchée (ouf)
*
*--------------------------------------

setPOINTER
	sec
	sbc	#1
	asl
	bcc	setPOINTER2	; if we exceed 256
	inc	dpDATA+1	; so, go to next page
	bne	setPOINTER2
	inc	dpDATA+2	; or next bank
	
setPOINTER2	tay
	lda	(dpDATA),y	; Récupère l'adresse
	sta	dpFROM	; du pointeur
	iny		; et la sauvegarde
	lda	(dpDATA),Y
	sta	dpFROM+1

	lda	dpFROM	; from an offset to an address
	clc
	adc	ptrDATA
	sta	dpFROM
	lda	dpFROM+1
	adc	ptrDATA+1
	sta	dpFROM+1
	
	ldy	dpFROM	; retourne le pointeur à l'appelant
	ldx	dpFROM+1
	rts

*--------------------------------------
* calcNEXTSTRING
*
* Calcule l'adresse de la prochaine chaîne Pascal
* à partir de dpFROM.
*
* La formule est @dpFROM + 1 + dpFROM => new dpFROM
*
*--------------------------------------

calcNEXTSTRING
	ldy	#0		; prend la longueur de la chaîne Pascal
	lda	(dpFROM),y
	clc
	adc	#1		; +1 pour l'octet de la longueur
	adc	dpFROM		; ajoute l'adresse actuelle
	sta	dpFROM		
	lda	dpFROM+1
	adc	#0
	sta	dpFROM+1		; et on a l'adresse suivante
	rts

*------------------------------------------------------------------------------
* Les variables du moteur
*------------------------------------------------------------------------------

*--- Variables pour le texte

* Le tableau suivant sert à transformer les caractères saisis en caractères
* comparables avec le dictionnaire où tout est en lettres minuscules.
* Ainsi :
* - "B" ($42) sera remplacé par "b" ($62)
* - "Z" ($5A) sera remplacé par "z" ($7A)
*
* Cela permet de simplifier le dictionnaire
* Ainsi :
* - "Bonjour" et "bonjour" sont en doublon, "bonjour" suffit

tblSTRING		; tableau de bascule de caractères (sur 7 bits)
	hex	000102030405060708090A0B0C0D0E0F	; 00-0F
	hex	101112131415161718191A1B1C1D1E1F	; 10-1F
	hex	202122232425262728292A2B2C2D2E2F	; 20-2F
	hex	303132333435363738393A3B3C3D3E3F	; 30-3F
	hex	616162636465666768696A6B6C6D6E6F	; 40-4F à:40/61
	hex	707172737475767778797A5B635D5E5F	; 50-5F ç:5C/63
	hex	606162636465666768696A6B6C6D6E6F	; 60-6F
	hex	707172737475767778797A6575657E7F	; 70-7F é:7B/65 è:7D/65 ù:7C/75

lenMOT	ds	1	; longueur de la chaîne : 100 caractères

idxMOTS	ds	1	; index dans la liste des mots trouvés
listeMOTS	ds	3	; les index des mots trouvés

idxSTRING	ds	1	; index courant dans la chaîne Pascal, utile pour le découpage des mots
lenSTRING	ds	1	; longueur d'une chaîne Pascal
mySTRING	ds	sizeMOT+10	; la chaîne saisie par le joueur, modifiée par moi en lettres minuscules

lenWORD	ds	1	; longueur du mot
myWORD	ds	sizeMOT+10	; le mot en question (eh oui, ça peut être un mot de 100 caractères)

*--- Données par défaut

dataVERSION		; 0 - minimum version required 1.0 here
	dfb	engineVERSION
dataMEMORY		; 1 - the game runs fine on a 64K machine
	dfb	data64K
dataTEXT		; 2 - text is in 80-col
	dfb	text80COL
dataPICTURES		; 3 - pictures are HGR monochrome
	dfb	picHGRMONO
picCOMPRESSION		; 4 - no compression
	dfb	compNONE
lettresOK		; 5 - définit les lettres pour dire oui pour les messages du système
	asc	"Oo"
tailleSYSTEMDICTIONNAIRE	; 6 - nombre de mots dans le dictionnaire systeme
	dfb	16+1
tailleDICTIONNAIRE	; 7 - nombre de mots de dans le dictionnaire du jeu
	dfb	100+1
nbLIEUX		; 8 - nombre de décors dans le jeu
	dfb	20
nbPIECES		; 9 - nombre de pièces dans le jeu
	dfb	12
imageTITRE		; 10 - numéro de l'image titre
	dfb	12
messageTITRE		; 11 - message de titre
	dfb	74
dialogueTITRE		; 12 - message de titre
	dfb	1
nbCONDITIONS		; 13 - nombre de conditions pour gagner
	dfb	22
deathCONDITION		; 14 - condition à vérifier qu'on ne voit pas mort !
	dfb	28
conditions		; 15 - le tableau des conditions du jeu (par défaut, tout est à faux (=0))
	ds	sizeCONDITIONS

*--- Variables internes
	
numSYSTEMMESSAGE	; numéro du message systeme à afficher
	ds	1
numSYSTEMDICTIONNAIRE	; numéro du dictionnaire système choisi
	ds	1
numDICTIONNAIRE	; numéro du dictionnaire choisi
	ds	1
numMESSAGEIMAGE	; numéro du message par image
	ds	1
numMESSAGE		; numéro du message du jeu à afficher
	ds	1	
numDIALOGUE		; numéro du dialogue à afficher
	ds	1
numDESSIN		; numéro du dessin en cours
	ds	1

